from osv import fields,osv

class ir_sequence(osv.osv):
    _inherit = 'ir.sequence'
    _columns = {
        'reset_with_prefix' : fields.boolean('Reset With Prefix', help='If checked, the sequence number will be reset when the prefix changes.'),
        'reset_cache' : fields.char('Reset Cache', size=64),
    }

    def get_id(self, cr, uid, sequence_id, test='id=%s', context=None):
        ir_sequence_obj = self.pool.get('ir.sequence')
        if test not in ('id=%s', 'code=%s'):
            raise ValueError('invalid test')

        cr.execute('SELECT id, number_next, prefix, suffix, padding, reset_with_prefix, reset_cache FROM ir_sequence WHERE '+test+' AND active=%s FOR UPDATE', (sequence_id, True))
        res = cr.dictfetchone()

        if res:
            prefix = ir_sequence_obj._process(res['prefix'])
            rest = '%%0%sd' % res['padding'] + ir_sequence_obj._process(res['suffix'])

            if not res['reset_with_prefix']:
                cr.execute('UPDATE ir_sequence SET number_next=number_next+number_increment WHERE id=%s AND active=%s', (res['id'],True))

                if res['number_next']:
                    return prefix + rest % res['number_next']
                else:
                    return prefix + rest 
            else:
                if not res['reset_cache']:
                    res['reset_cache'] = prefix
                    cr.execute("""UPDATE ir_sequence
                                     SET reset_cache = %s
                                     WHERE id=%s""", (prefix, res['id']))

                if res['reset_cache'] == prefix:
                    cr.execute('UPDATE ir_sequence SET number_next=number_next+number_increment WHERE id=%s', (res['id'],))

                    if res['number_next']:
                        return prefix + rest % res['number_next']
                    else:
                        return prefix + rest 
                else:
                    cr.execute("""UPDATE ir_sequence
                                     SET number_next = 1 + number_increment,
                                         reset_cache = %s
                                     WHERE id = %s""", (prefix, res['id']))
                
                    return prefix + rest % 1

        return False
ir_sequence()
